import { getCurrentInstance, onBeforeUnmount, ref, watch, watchEffect } from "vue";
import { injectHead, resolveUnrefHeadInput } from "../../index";
export function useHead(input, options = {}) {
  const head = injectHead();
  const vm = getCurrentInstance();
  if (!vm) {
    head.push(input, options);
    return;
  }
  const resolvedInput = ref({});
  watchEffect(() => {
    resolvedInput.value = resolveUnrefHeadInput(input);
  });
  let entry;
  watch(resolvedInput, (e) => {
    if (!entry)
      entry = head.push(e, options);
    else
      entry.patch(e);
  }, { immediate: true });
  onBeforeUnmount(() => {
    entry?.dispose();
  });
}
